
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Coin_Classes &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    
<a class="navbar-brand" href="../index.html">
<p class="title">Battery SOH</p>
</a>

    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../rst%20files/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Coin_Classes</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">math</span>
<span class="kn">from</span> <span class="nn">Cleaning</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">os</span>

<div class="viewcode-block" id="Dataset_Coin"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Dataset_Coin">[docs]</a><span class="k">class</span> <span class="nc">Dataset_Coin</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Dataset for storing the raw coin-type Na-ion battery data provided by</span>
<span class="sd">    Jean-Marie Tarascon and Sathiya Mariyappan.</span>

<span class="sd">    Each dataset contains information for one set of experiments, which usually</span>
<span class="sd">    contain 2 cells, the data of which are usually separated in two parts. The</span>
<span class="sd">    first part contains the first 10 charge-discharge cycles (formation step),</span>
<span class="sd">    and the second usually contains a rest period (of 1 week) and the rest of</span>
<span class="sd">    the charge-discharge cycles. In a few cases, the rest period may show up in</span>
<span class="sd">    the first part instead of the first, or in a third part.</span>

<span class="sd">    The data for each experiment set is in a folder with the</span>
<span class="sd">    respective battery number, in &#39;/Datasets/Tarascon/Coins/Raw_Data&#39; . The</span>
<span class="sd">    files are named as follows:</span>
<span class="sd">    &#39;Cell&#39; + cell number + &#39;_&#39; + part number + &#39;.txt&#39;</span>

<span class="sd">    .. note::</span>
<span class="sd">        The console must already be in the correct directory upon calling of the</span>
<span class="sd">        function (/Datasets/Tarascon/Coins/Raw_Data).</span>

<span class="sd">    The data contains time [s], voltage [V], current [I] and capacity [A.h]</span>
<span class="sd">    measurements. The capacity should, however, be normalized by the sodium mass,</span>
<span class="sd">    which is given in the excel spreadsheet present in the same directory:</span>
<span class="sd">    &#39;Information regarding cells.xlsx&#39;. The code will automatically read it and</span>
<span class="sd">    save all of the information contained.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    battery_number : int</span>
<span class="sd">        The battery number, so the right directory can be opened</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    number : int</span>
<span class="sd">        The battery number informed upon initialization.</span>
<span class="sd">    Name : str</span>
<span class="sd">        The battery&#39;s name: &#39;B&#39;+str(battery_number).zfill(4).</span>
<span class="sd">        For battery_number = 1: Name = B0001; 12: Name = B0012 etc.</span>
<span class="sd">    electrode_batch : str</span>
<span class="sd">        Information about the thickness of the coating: &#39;High Energy&#39; will</span>
<span class="sd">        relate to thick coating, while &#39;High Power&#39; will relate to thin.</span>
<span class="sd">    amb_T : float</span>
<span class="sd">        Temperature of the experiment. Usually (if not always) 55ºC.</span>
<span class="sd">    chemistry : str</span>
<span class="sd">        Information on the chemistry of the battery. The actual chemicals used </span>
<span class="sd">        are hidden because of secrecy reasons.</span>
<span class="sd">    additive : str</span>
<span class="sd">        Information on the additives used (if any).</span>
<span class="sd">    NVPF_mass_1 : float</span>
<span class="sd">        The mass [mg] of the NVPF electrode used for the first cell.</span>
<span class="sd">    NVPF_mass_2 : float or str</span>
<span class="sd">        The mass [mg] of the NVPF electrode used for the second cell or &#39;-&#39; when</span>
<span class="sd">        not applicable.</span>
<span class="sd">    cell : list(Coin_Cell)</span>
<span class="sd">        A list of Coin_Cell objects containing information and data of the</span>
<span class="sd">        specific cells.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">battery_number</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">battery_number</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span>

        <span class="c1"># Information from the excel spreadsheet:</span>
        <span class="n">excel_df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_excel</span><span class="p">(</span><span class="s1">&#39;Information regarding cells.xlsx&#39;</span><span class="p">)</span>
        <span class="n">row</span> <span class="o">=</span> <span class="n">excel_df</span><span class="p">[</span><span class="n">excel_df</span><span class="p">[</span><span class="s1">&#39;FOLDER Name &#39;</span><span class="p">]</span><span class="o">.</span><span class="n">eq</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)]</span>
        <span class="n">np_row</span> <span class="o">=</span> <span class="n">row</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">electrode_batch</span> <span class="o">=</span> <span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">2</span><span class="p">][</span><span class="o">-</span><span class="mi">2</span><span class="p">])[</span><span class="mi">0</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">chemistry</span> <span class="o">=</span> <span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">3</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">additive</span> <span class="o">=</span> <span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">4</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">NVPF_mass_1</span> <span class="o">=</span> <span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">5</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">NVPF_mass_2</span> <span class="o">=</span> <span class="n">np_row</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">6</span><span class="p">]</span>

        <span class="c1"># The actual charge/discharge data.</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">battery_number</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cell</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">cell</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">3</span><span class="p">):</span>
            <span class="n">cell_file</span> <span class="o">=</span> <span class="s1">&#39;Cell&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">cell</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;_&#39;</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cell</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Coin_Cell</span><span class="p">(</span><span class="n">cell_file</span><span class="p">,</span> <span class="n">cell</span><span class="p">,</span>
                                       <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;NVPF_mass_&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">cell</span><span class="p">))))</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span></div>


        <span class="c1"># Reading the actual data:</span>

<div class="viewcode-block" id="Coin_Cell"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Coin_Cell">[docs]</a><span class="k">class</span> <span class="nc">Coin_Cell</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for storing the data for a single coin-like cell of Na-ion data.</span>

<span class="sd">    This follows from the :class:`Dataset_Coin` class.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    cell_file : str</span>
<span class="sd">        The first half of the file&#39;s name. The second half will be added later</span>
<span class="sd">        according to the part number. The ``cell_file`` looks something like:</span>
<span class="sd">        *&#39;Cell1_&#39;*.</span>
<span class="sd">    cell_number : int</span>
<span class="sd">        The number of the cell.</span>
<span class="sd">    mass : float</span>
<span class="sd">        The mass of the cell [mg].</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    number : int</span>
<span class="sd">        The cell number.</span>
<span class="sd">    mass : float</span>
<span class="sd">        The mass of the cell [mg].</span>
<span class="sd">    part : list(Coin_Part)</span>
<span class="sd">        A list of Coin_Part objects, containing the different parts of the data</span>
<span class="sd">        (from 1 to 3 entries).</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cell_file</span><span class="p">,</span> <span class="n">cell_number</span><span class="p">,</span> <span class="n">mass</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">cell_number</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mass</span> <span class="o">=</span> <span class="n">mass</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">part</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">part</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">4</span><span class="p">):</span>
            <span class="n">part_file</span> <span class="o">=</span> <span class="n">cell_file</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">part</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">part</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Coin_Part</span><span class="p">(</span><span class="n">part_file</span><span class="p">))</span>
            <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
                <span class="k">if</span> <span class="p">(</span><span class="n">part</span> <span class="o">==</span> <span class="mi">1</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">part</span> <span class="o">==</span> <span class="mi">2</span><span class="p">):</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">part</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="kc">None</span><span class="p">)</span>
                <span class="k">elif</span> <span class="n">part</span> <span class="o">==</span> <span class="mi">3</span><span class="p">:</span>
                    <span class="k">break</span></div>

<div class="viewcode-block" id="Coin_Part"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Coin_Part">[docs]</a><span class="k">class</span> <span class="nc">Coin_Part</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for storing the data contained in each &#39;.txt&#39; cell part file.</span>

<span class="sd">    This class follows from the Coin_Cell class.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    part_file : str</span>
<span class="sd">        The final file_name for the part file.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    time : np.ndarray</span>
<span class="sd">        The time stamps [s].</span>
<span class="sd">    meas_v : np.ndarray</span>
<span class="sd">        The measured voltage [V].</span>
<span class="sd">    meas_i : np.ndarray</span>
<span class="sd">        The measured current [mA].</span>
<span class="sd">    meas_q : np.ndarray</span>
<span class="sd">        The measured capacity [A.h].</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">part_file</span><span class="p">):</span>

        <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">part_file</span><span class="p">,</span> <span class="n">delimiter</span><span class="o">=</span><span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">columns</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">4</span><span class="p">:</span>
            <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">drop</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">columns</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">df</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">:</span><span class="mi">1</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">df</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">df</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:</span><span class="mi">3</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_q</span> <span class="o">=</span> <span class="n">df</span><span class="p">[:,</span> <span class="mi">3</span><span class="p">:</span><span class="mi">4</span><span class="p">]</span></div>

<div class="viewcode-block" id="Clean_Coin_Battery"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Clean_Coin_Battery">[docs]</a><span class="k">class</span> <span class="nc">Clean_Coin_Battery</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for storing the cleaned data from a coin-type battery provided by</span>
<span class="sd">    Jean-Marie Tarascon and Sathiya Mariyappan.</span>

<span class="sd">    This will take a Dataset_Coin object, save its cells in the same way</span>
<span class="sd">    (attribute cell, which is a list of class:`Clean_Cell` objects this time)</span>
<span class="sd">    but separate the cycles contained in each part in different objects</span>
<span class="sd">    (specifically class:`Coin_Cycle` objects) - for more information see the</span>
<span class="sd">    documentation for the class:`Clean_Cell` class. As in the</span>
<span class="sd">    class:`Nasa_classes.Clean_Battery` class, the cycles are then separated into</span>
<span class="sd">    couples of charge and discharge cycles and saved in attribute</span>
<span class="sd">    ``cycle_couples``</span>

<span class="sd">    .. note::</span>
<span class="sd">        Many attributes are directly inherited from the ``Dataset_Coin`` class</span>
<span class="sd">        given as input to the initialization. Because of this, they aren&#39;t</span>
<span class="sd">        described in this documentation, only in the ``Dataset_Coin``&#39;s. These</span>
<span class="sd">        attributes are: ``Name``, ``number``, ``electrode_batch``, ``amb_T``,</span>
<span class="sd">        ``chemistry``, ``additive``, ``NVPF_mass_1``, ``NVPF_mass_2``.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Battery : Dataset_Coin</span>
<span class="sd">        The Dataset_Coin object from which we&#39;ll be extracting and treating the</span>
<span class="sd">        data.</span>
<span class="sd">    threshold : float, default = 0.1</span>
<span class="sd">        The minimum value of capacity [A.h, before normalization per mass] a</span>
<span class="sd">        cycle must have for it to be considered as relevant. Otherwise, the</span>
<span class="sd">        cycle is discarded.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    cell : list(Clean_Cell)</span>
<span class="sd">        List with the Clean_Cell objects containing information about each cell.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Battery</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">):</span>

        <span class="c1"># Base information:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">Name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">number</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">electrode_batch</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">electrode_batch</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">amb_T</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">chemistry</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">chemistry</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">additive</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">additive</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">NVPF_mass_1</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">NVPF_mass_1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">NVPF_mass_2</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">NVPF_mass_2</span>

        <span class="c1"># Now for the cells and cycles:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cell</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">cell</span> <span class="ow">in</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cell</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cell</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Clean_Cell</span><span class="p">(</span><span class="n">cell</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">Name</span><span class="p">,</span> <span class="n">amb_T</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span><span class="p">,</span>
                                        <span class="n">threshold</span><span class="o">=</span><span class="n">threshold</span><span class="p">))</span>

            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cell</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">cycle</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">cell</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span></div>

<div class="viewcode-block" id="Clean_Cell"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Clean_Cell">[docs]</a><span class="k">class</span> <span class="nc">Clean_Cell</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class that stores the cleaned data for each coin-type cell.</span>

<span class="sd">    This follows from the :class:`Clean_Coin_Battery` class.</span>

<span class="sd">    .. note ::</span>
<span class="sd">        Some of this class&#39;s attributes are directly inherited from the</span>
<span class="sd">        :class:`Coin_Cell` class which is used as a base for the cleaning and thus</span>
<span class="sd">        won&#39;t be cited in this documentation. These attributes are: ``number``,</span>
<span class="sd">        ``mass``.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    cell : Coin_Cell</span>
<span class="sd">        The Coin_Cell object used as a base.</span>
<span class="sd">    Name : str</span>
<span class="sd">        The battery&#39;s name. This isn&#39;t a intrinsically necessary information to</span>
<span class="sd">        have in this class, but it is defined because dataset creation classes</span>
<span class="sd">        may call for a battery&#39;s ``Name`` attribute, so this avoids unnecessary</span>
<span class="sd">        errors/warnings.</span>
<span class="sd">    amb_T : float, default = 55.</span>
<span class="sd">        The ambient temperature where the experiments where held.</span>
<span class="sd">    threshold : float, default = 0.1</span>
<span class="sd">        The minimum value of capacity [A.h, before normalization per mass] a</span>
<span class="sd">        cycle must have for it to be considered as relevant. Otherwise, the</span>
<span class="sd">        cycle is discarded.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    separation : int</span>
<span class="sd">        The cycle number that separates the first part of the data from the</span>
<span class="sd">        second. This is mostly for documenting than anything.</span>
<span class="sd">    cycle : list[Coin_Cycle]</span>
<span class="sd">        A list with all of the tested cycles. See ``Coin_Cycle`` and</span>
<span class="sd">        ``clean_coin_cycle`` (in `Cleaning.py`) documentations for details on</span>
<span class="sd">        the class structure and on how the cycles are treated.</span>
<span class="sd">    raw_couples : list[tuple(int)]</span>
<span class="sd">        The number of the charge and discharge cycles in each couple.</span>
<span class="sd">        Example:</span>
<span class="sd">        self.couples[k] = (charge cycle number, discharge cycle number)</span>
<span class="sd">    couples : list[tuple(int)]</span>
<span class="sd">        Exactly like the ``raw_couples`` attribute, but without the entries that</span>
<span class="sd">        are judged as abnormal or that have missing datapoints or that are too</span>
<span class="sd">        short etc.</span>
<span class="sd">    cycle_couple : list[tuple(Clean_Cycle)]</span>
<span class="sd">        The Coin_Cycle objects corresponding to each couple.</span>
<span class="sd">        self.cycle_couple[k] = (charge Coin_Cycle, discharge Coin_Cycle)</span>
<span class="sd">    capacity_curve : np.ndarray</span>
<span class="sd">        Array with the capacity value for each discharge cycle. The first</span>
<span class="sd">        column corresponds to the cycle&#39;s number and the second one to the</span>
<span class="sd">        capacity value (normalized by the electrode&#39;s mass) [A.h/g].</span>
<span class="sd">    C_rate : float</span>
<span class="sd">        The C rate associated to the battery for nondimensionning the</span>
<span class="sd">        current [A].</span>
<span class="sd">    Q_nominal : float</span>
<span class="sd">        The battery&#39;s nominal capacity (for nondimensionning the SOH) [A.h].</span>
<span class="sd">    V_nominal : float</span>
<span class="sd">        The battery&#39;s nominal voltage (for nondimensionning the voltage) [V].</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cell</span><span class="p">,</span> <span class="n">Name</span><span class="p">,</span> <span class="n">amb_T</span><span class="o">=</span><span class="mf">55.</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">C_rate</span> <span class="o">=</span> <span class="mf">0.1284</span><span class="o">*</span><span class="n">cell</span><span class="o">.</span><span class="n">mass</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Q_nominal</span> <span class="o">=</span> <span class="mf">0.1284</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">V_nominal</span> <span class="o">=</span> <span class="mf">4.3</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mass</span> <span class="o">=</span> <span class="n">cell</span><span class="o">.</span><span class="n">mass</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">Name</span>

        <span class="n">threshold</span> <span class="o">=</span> <span class="n">threshold</span><span class="o">/</span><span class="n">cell</span><span class="o">.</span><span class="n">mass</span>
        <span class="n">last_time</span> <span class="o">=</span> <span class="mi">0</span>   <span class="c1"># To maintain battery history</span>
        <span class="k">for</span> <span class="n">part_nb</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">cell</span><span class="o">.</span><span class="n">part</span><span class="p">)):</span>
            <span class="n">part</span> <span class="o">=</span> <span class="n">cell</span><span class="o">.</span><span class="n">part</span><span class="p">[</span><span class="n">part_nb</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">part_nb</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">separation</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="p">)</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">separation</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>  <span class="c1"># First part was None</span>
                    <span class="c1"># We take the first cycles into account...</span>
                    <span class="n">cycle_number</span> <span class="o">=</span> <span class="mi">21</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">cycle_number</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">separation</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">cycle_number</span> <span class="o">=</span> <span class="mi">0</span>

            <span class="k">if</span> <span class="n">part</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>

                <span class="n">data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">part</span><span class="o">.</span><span class="n">meas_v</span><span class="p">,</span> <span class="n">part</span><span class="o">.</span><span class="n">meas_i</span><span class="p">,</span>
                                       <span class="n">part</span><span class="o">.</span><span class="n">meas_q</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

                <span class="c1"># if time is not None:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">separate_coin_cycles</span><span class="p">(</span><span class="n">part</span><span class="o">.</span><span class="n">time</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">amb_T</span><span class="o">=</span><span class="n">amb_T</span><span class="p">,</span>
                                          <span class="n">cycle_number</span><span class="o">=</span><span class="n">cycle_number</span><span class="p">,</span>
                                          <span class="n">last_time</span><span class="o">=</span><span class="n">last_time</span><span class="p">)</span>

                <span class="n">last_time</span> <span class="o">=</span> <span class="n">part</span><span class="o">.</span><span class="n">time</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

        <span class="n">dis_nb</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">couples</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">idx</span><span class="p">,</span> <span class="n">cycle</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;discharge&#39;</span><span class="p">:</span>
                <span class="n">dis_nb</span> <span class="o">=</span> <span class="n">idx</span>
            <span class="k">elif</span> <span class="n">cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;charge&#39;</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">dis_nb</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span><span class="p">:</span>
                    <span class="n">chr_nb</span> <span class="o">=</span> <span class="n">idx</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_nb</span><span class="p">,</span> <span class="n">dis_nb</span><span class="p">))</span>
                    <span class="n">dis_nb</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>

        <span class="c1"># print(self.couples)</span>
        <span class="k">for</span> <span class="n">couple</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="p">:</span> <span class="c1"># For each charge/discharge couple:</span>
            <span class="c1"># Saving the cycles</span>
            <span class="n">chr_cycle</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="n">couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>    <span class="c1"># The charge cycle</span>
            <span class="n">dis_cycle</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="n">couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span>    <span class="c1"># The discharge cycle</span>

            <span class="c1"># For the discharge cycle first:</span>
            <span class="k">if</span> <span class="n">math</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">dis_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">):</span> <span class="c1"># if the capacity is nan:</span>
                <span class="k">continue</span>    <span class="c1"># skip this couple</span>
            <span class="k">elif</span> <span class="n">dis_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span> <span class="o">&lt;</span> <span class="n">threshold</span><span class="p">:</span>
                <span class="k">continue</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_cycle</span><span class="p">,</span> <span class="n">dis_cycle</span><span class="p">))</span>  <span class="c1"># Saving the cycle couple</span>

        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">)):</span>
            <span class="n">capacity_point</span> <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>     <span class="c1"># Defining the capacity point</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">capacity_point</span><span class="p">)</span>                      <span class="c1"># Saving the capacity point</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="p">)</span>

        <span class="c1"># Searching for outliers in the capacity data</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">cycle_couple</span><span class="p">,</span> <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">Outliers</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">,</span>
                                                    <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="n">cycle_couple</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">capacity_curve</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">pass</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">raw_couples</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">couples</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">couples</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="k">for</span> <span class="n">cycle_couple</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">:</span>
            <span class="n">chr_nb</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">number</span>
            <span class="n">dis_nb</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">number</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_nb</span><span class="p">,</span> <span class="n">dis_nb</span><span class="p">))</span>

<div class="viewcode-block" id="Clean_Cell.separate_coin_cycles"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Clean_Cell.separate_coin_cycles">[docs]</a>    <span class="k">def</span> <span class="nf">separate_coin_cycles</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">time</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">amb_T</span><span class="o">=</span><span class="mf">55.</span><span class="p">,</span> <span class="n">cycle_number</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
                             <span class="n">last_time</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">50</span><span class="p">):</span>

        <span class="sd">&quot;&quot;&quot;Function for separating the cycles from the</span>
<span class="sd">        :class:`Coin_Part`&#39;s raw data.</span>

<span class="sd">        The dataset&#39;s raw data comes with all of the cycles concatenated.</span>
<span class="sd">        This function will separate them from each other and add them to</span>
<span class="sd">        ``Clean_Cell``&#39;s ``cycle`` attribute (list of :class:`Coin_Cycle`</span>
<span class="sd">        objects).</span>

<span class="sd">        The function starts by seeing when the first cycle starts (Current ≠ 0).</span>
<span class="sd">        In some cases, the file being read corresponds solely to the rest</span>
<span class="sd">        period, in these cases the current = 0 all the way so the function</span>
<span class="sd">        prints &quot;I = 0&quot; and quits by returning ``None``.</span>

<span class="sd">        A `while` loop is then used to check when the current changes sign</span>
<span class="sd">        (switching from charge, I &gt; 0, to discharge, I &lt; 0, and vice-versa).</span>
<span class="sd">        The index of the following cycle is saved in ``final_idx``. Only data</span>
<span class="sd">        before ``final_idx`` is then treated for the current cycle.</span>
<span class="sd">        If the current no longer changes sign (the last cycle is reached), an</span>
<span class="sd">        ``IndexError`` is raised, which leads the ``try`` statement another way</span>
<span class="sd">        in order to later stop the loop.</span>

<span class="sd">        Knowing the index window of the cycle, a moving window outlier detection</span>
<span class="sd">        is done through ``pandas``&#39;s ``rolling(...)`` method. The window and</span>
<span class="sd">        threshold were *hand-picked* to eliminate big outliers and avoid</span>
<span class="sd">        eliminating curve detail. A interquantile range method was also tested</span>
<span class="sd">        but yielded worse results.</span>

<span class="sd">        Finally, if the last few points of the cycle have ``Current = 0``, these</span>
<span class="sd">        points are taken away. This happens in some cases because the only way</span>
<span class="sd">        one cycle is separated from the other is by checking when the current</span>
<span class="sd">        changes sign.</span>

<span class="sd">        Finally, if the cycle is too short (&lt; ``min_len``) it is discarded (not</span>
<span class="sd">        added to the ``self.cycle`` list).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        time : np.ndarray</span>
<span class="sd">            Time stamps [s].</span>
<span class="sd">        data : np.ndarray</span>
<span class="sd">            The rest of the data (voltage [V], current [mA] and capacity [A.h])</span>
<span class="sd">            concatenated in one array (features in columns, axis=1).</span>
<span class="sd">        amb_T : float, default = 55.</span>
<span class="sd">            The ambient temperature [ºC].</span>
<span class="sd">        cycle_number : int, default = 0</span>
<span class="sd">            The cycle number.</span>
<span class="sd">        last_time : float, default = 0</span>
<span class="sd">            Last time stamp from the last battery *part* cleaned.</span>

<span class="sd">            In some cases, the time stamps from one *part* to the next are reset</span>
<span class="sd">            to zero (example: from the *part* before the rest and the one right</span>
<span class="sd">            after).</span>

<span class="sd">            Usually only ∆t is important for analyses, but having absolute</span>
<span class="sd">            information in better and might come in handy in the future.</span>
<span class="sd">        min_len : int, default = 50</span>
<span class="sd">            The minimum length (number of points) the cycle must have for it to</span>
<span class="sd">            be considered relevant.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">mass</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">mass</span>

        <span class="k">if</span> <span class="n">time</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">last_time</span><span class="p">:</span>
            <span class="n">time</span> <span class="o">+=</span> <span class="n">last_time</span>

        <span class="n">Current</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>

        <span class="c1"># Checking where the cycles begin (I ≠ 0)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">idx_begin</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Current</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
        <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;I = 0&#39;</span><span class="p">)</span>
            <span class="k">return</span> <span class="kc">None</span>

        <span class="n">data</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="n">idx_begin</span><span class="p">:,</span> <span class="p">:]</span>
        <span class="n">time</span> <span class="o">=</span> <span class="n">time</span><span class="p">[</span><span class="n">idx_begin</span><span class="p">:,</span> <span class="p">:]</span>
        <span class="n">Current</span> <span class="o">=</span> <span class="n">Current</span><span class="p">[</span><span class="n">idx_begin</span><span class="p">:,</span> <span class="p">:]</span>

        <span class="n">start_idx</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">run</span> <span class="o">=</span> <span class="kc">True</span>

        <span class="k">while</span> <span class="n">run</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>

                <span class="c1"># Checking when the current changes sign:</span>
                <span class="n">final_idx</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span>
                    <span class="n">np</span><span class="o">.</span><span class="n">sign</span><span class="p">(</span><span class="n">Current</span><span class="p">[</span><span class="n">start_idx</span><span class="p">:,</span> <span class="mi">0</span><span class="p">])</span> <span class="o">==</span> <span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sign</span><span class="p">(</span>
                        <span class="n">Current</span><span class="p">[</span><span class="n">start_idx</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>
                    <span class="p">)</span>
                <span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>

                <span class="n">final_idx</span> <span class="o">=</span> <span class="n">final_idx</span> <span class="o">+</span> <span class="n">start_idx</span>
            <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
                <span class="c1"># We are in the last cycle</span>
                <span class="n">final_idx</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">Current</span><span class="p">)</span>
                <span class="n">run</span> <span class="o">=</span> <span class="kc">False</span>  <span class="c1"># Will stop the while loop.</span>

            <span class="n">cycle_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">time</span><span class="p">[</span><span class="n">start_idx</span><span class="p">:</span> <span class="n">final_idx</span><span class="p">,</span> <span class="p">:],</span>
                                         <span class="n">data</span><span class="p">[</span><span class="n">start_idx</span><span class="p">:</span> <span class="n">final_idx</span><span class="p">,</span> <span class="p">:]],</span>
                                        <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

            <span class="n">cycle_data</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">Input_outliers_v3</span><span class="p">(</span><span class="n">cycle_data</span><span class="p">,</span> <span class="n">feature_index</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                                              <span class="n">window</span><span class="o">=</span><span class="mi">100</span><span class="p">)</span>

            <span class="k">if</span> <span class="n">cycle_data</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">]</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">idx</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">cycle_data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:</span><span class="mi">3</span><span class="p">]</span> <span class="o">==</span> <span class="mi">0</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">cycle_data</span> <span class="o">=</span> <span class="n">cycle_data</span><span class="p">[:</span><span class="n">idx</span><span class="p">,</span> <span class="p">:]</span>

            <span class="n">start_idx</span> <span class="o">=</span> <span class="n">final_idx</span>

            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">cycle_data</span><span class="p">)</span> <span class="o">&gt;=</span> <span class="n">min_len</span><span class="p">:</span>
                <span class="n">cycle_class</span> <span class="o">=</span> <span class="n">Coin_Cycle</span><span class="p">(</span><span class="n">cycle_data</span><span class="p">,</span> <span class="n">cycle_number</span><span class="p">,</span> <span class="n">mass</span><span class="p">,</span>
                                         <span class="n">amb_T</span><span class="o">=</span><span class="n">amb_T</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">cycle_class</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">pass</span>
            <span class="n">cycle_number</span> <span class="o">+=</span> <span class="mi">1</span></div></div>

<div class="viewcode-block" id="Coin_Cycle"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Coin_Cycle">[docs]</a><span class="k">class</span> <span class="nc">Coin_Cycle</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for storing information about each cycle of Na-ion battery dataset.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    data : np.ndarray</span>
<span class="sd">        Array containing all of the important data (voltage [V], current [mA] and</span>
<span class="sd">        capacity [A.h]) concatenated in one array (features in columns, axis=1).</span>
<span class="sd">    number : int</span>
<span class="sd">        The cycle number.</span>
<span class="sd">    mass : float</span>
<span class="sd">        The cell&#39;s mass [mg].</span>
<span class="sd">    amb_T : float, default = 55.</span>
<span class="sd">        The ambient temperature where the experiments where held.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    number : int</span>
<span class="sd">        The cycle number</span>
<span class="sd">    amb_T : float</span>
<span class="sd">        The ambient temperature where the experiments where held.</span>
<span class="sd">    data : Coin_Data</span>
<span class="sd">        Class with the actual information.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">number</span><span class="p">,</span> <span class="n">mass</span><span class="p">,</span> <span class="n">amb_T</span> <span class="o">=</span> <span class="mf">55.</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">number</span>
        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">sign</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">])</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="s1">&#39;charge&#39;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="s1">&#39;discharge&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="n">amb_T</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">Coin_Data</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="n">mass</span><span class="p">)</span></div>

<div class="viewcode-block" id="Coin_Data"><a class="viewcode-back" href="../rst%20files/COIN.html#Coin_Classes.Coin_Data">[docs]</a><span class="k">class</span> <span class="nc">Coin_Data</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for storing information about each cycle of Na-ion battery dataset.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    data : np.ndarray</span>
<span class="sd">        Array containing all of the important data (voltage [V], current [A] and</span>
<span class="sd">        capacity [A.h]) concatenated in one array (features in columns, axis=1).</span>
<span class="sd">    mass : float</span>
<span class="sd">        The cell&#39;s mass [mg].</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    meas_v : ndarray[floats]</span>
<span class="sd">        Battery terminal voltage [V].</span>
<span class="sd">    meas_i : ndarray[floats]</span>
<span class="sd">        Battery output current [mA].</span>
<span class="sd">    meas_q : ndarray[floats]</span>
<span class="sd">        Battery capacity variatioon over time, normalized by the mass) [A.h/mg].</span>
<span class="sd">    time : ndarray[floats]</span>
<span class="sd">        Time vector for the cycle [s].</span>
<span class="sd">    capacity : float</span>
<span class="sd">        The capacity value normalized by the mass[A.h/mg].</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">mass</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">:</span><span class="mi">1</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:</span><span class="mi">3</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_q</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">3</span><span class="p">:</span><span class="mi">4</span><span class="p">]</span><span class="o">/</span><span class="n">mass</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="o">/</span><span class="n">mass</span></div>


<span class="c1">########################################################################################</span>



<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="kn">import</span> <span class="nn">pickle</span>

    <span class="c1"># For treating the raw data:</span>
    <span class="c1"># os.chdir(&#39;.//Datasets/Tarascon/Coins/Raw_Data&#39;)</span>
    <span class="c1"># for i in range(1, 7):</span>
    <span class="c1">#     print(i)</span>
    <span class="c1">#     Battery = Dataset_Coin(i)</span>
    <span class="c1">#     with open(Battery.Name+&#39;.txt&#39;, &#39;wb&#39;) as f:</span>
    <span class="c1">#         pickle.dump(Battery, f)</span>
    <span class="c1">#     Clean_Battery = Clean_Coin_Battery(Battery)</span>
    <span class="c1">#     print(Clean_Battery.Name)</span>
    <span class="c1">#     os.chdir(&#39;../&#39;)</span>
    <span class="c1">#     os.chdir(&#39;.//Clean_Batteries&#39;)</span>
    <span class="c1">#     with open(Clean_Battery.Name+&#39;.txt&#39;, &#39;wb&#39;) as f:</span>
    <span class="c1">#         pickle.dump(Clean_Battery, f)</span>
    <span class="c1">#</span>
    <span class="c1">#     os.chdir(&#39;../&#39;)</span>
    <span class="c1">#     os.chdir(&#39;.//Raw_Data&#39;)</span>

    <span class="c1">##</span>
    <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>
    <span class="kn">import</span> <span class="nn">re</span>

    <span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>

    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
        <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>
        <span class="c1"># Only take into account the battery files</span>
        <span class="k">if</span> <span class="n">match</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="o">==</span> <span class="s1">&#39;B0007.txt&#39;</span><span class="p">:</span>
            <span class="k">continue</span>

        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">Name</span><span class="p">)</span>
        <span class="n">Clean_Battery</span> <span class="o">=</span> <span class="n">Clean_Coin_Battery</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Clean_Batteries&#39;</span><span class="p">)</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">Clean_Battery</span><span class="o">.</span><span class="n">Name</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">Clean_Battery</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Raw_Data&#39;</span><span class="p">)</span>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>